// Copyright 1993 by Jon Dart.  All Rights Reserved.

#ifndef _CLOCK_H
#define _CLOCK_H

#include "color.h"
#include "types.h"
#include <time.h>
#include <windows.h>

class Clock
{
public:
    Clock( HWND parent );
    
    virtual ~Clock();
    
    void set_handle( const HWND parent );

    void reset();
    
    void start( const ColorType side );
    
    void pause();
    
    void resume();
    
    void stop();
    
    void update();
    
    time_t elapsed_time( const ColorType side )
    {
       return etime[side];	     
    }
    
    // a not-running clock may be stopped or paused.
    Boolean is_running() const
    {
        return running;	    
    }
    
    // a stopped clock can only be reset.
    Boolean is_stopped() const
    {
        return stopped;	    
    }

private:
    HWND pWin;
    Boolean running, was_reset, stopped;
    time_t etime[2];
    time_t last_start[2];
    ColorType side_to_move;
};

#endif

extern Clock *the_clock;

