// Copyright 1993 by Jon Dart.  All Rights Reserved.

#ifndef _OPTIONS_H
#define _OPTIONS_H

#include "search.h"
#include "types.h"
#include <string.h>

struct Preferences
{
   Boolean beep_after_move;
   Boolean beep_on_error;
   Boolean can_resign;
   Boolean randomize_moves;
   Boolean use_book;
   Boolean think_when_idle;
};

class Options
{
public:	
   Options();
   
   virtual ~Options();
   
   Search::Search_Type search_type() 
   {
      return my_search_type;	   
   }
 
   void set_search_type( Search::Search_Type type )
   {
      my_search_type = type;	   
   }
	
   Search::Search_Limit search_limit() 
   {
      return my_search_limit;
   }
 
   void set_search_limit( Search::Search_Limit limit )
   {
      my_search_limit = limit;
   }
   
   Boolean beep_after_move() const
   {
      return prefs.beep_after_move;	   
   }
	
   Boolean beep_on_error() const
   {
      return prefs.beep_on_error;
   }
	
   Boolean can_resign() const
   {
      return prefs.can_resign;
   }
	
   Boolean use_book() const
   {
      return prefs.use_book;
   }
   
   Boolean randomize_moves() const
   {
      return prefs.randomize_moves;	   
   }
   
   Boolean think_when_idle() const
   {
      return prefs.think_when_idle;
   }
   
   void update_preferences( const Preferences &p );
   
   void get_preferences( Preferences &p );
   
   void save();
   
private:	
    Search::Search_Type my_search_type;
    Search::Search_Limit my_search_limit;
    Preferences prefs;
    
};

#endif

extern Options *global_options;

