// Copyright 1994 by Jon Dart.  All Rights Reserved.

#include "srclimit.h"
#include <wpglob.h>

WPControlMap SearchLimitDialog::ControlMap[] = 
{
   cmRBgp( IDP_SEARCHTYPE, Search_Limit_Options, search_type, 2 )
   cmEdit( IDP_MOVES_OR_PLY, Search_Limit_Options, move_or_ply )
   cmEdit( IDP_MINUTES, Search_Limit_Options, time_limit )
   cmEnd( IDP_SEARCHTYPE )
};

SearchLimitDialog::SearchLimitDialog(WPWin *pwin, Search_Limit_Options *options)
: initial_search_type(options->search_type),
  WPDialogModal("SEARCHLIMITS", pwin, ControlMap, options)
{
   createWin();	     
}

void SearchLimitDialog::initDlg()
{
// Note: the Windows++ getControl function appears not to return valid
// data, at least when called from here, so we limit ourselves to direct
// Windows calls
   const HWND hDlg = getHwnd();
   hMoves_text = GetDlgItem(hDlg,IDP_MOVES_TEXT);
   hPly_text = GetDlgItem(hDlg,IDP_PLY_TEXT);
   hMinutes_field = GetDlgItem(hDlg,IDP_MINUTES);
   hMinutes_text = GetDlgItem(hDlg,IDP_MINUTES_TEXT);
   if (initial_search_type == 0)
      do_fixed_ply();
   else
      do_time_limit();
}

void SearchLimitDialog::do_fixed_ply()
{
   ShowWindow(hMinutes_field,SW_HIDE);
   ShowWindow(hMinutes_text,SW_HIDE);
   EnableWindow(hMinutes_text,FALSE);
   // Hide the "Moves:" static box with a child window of the same
   // size that says "Ply:"
   ShowWindow(hPly_text,SW_SHOWNORMAL);
   ShowWindow(hMoves_text,SW_HIDE);
}

void SearchLimitDialog::do_time_limit()
{
   ShowWindow(hMinutes_field,SW_SHOWNORMAL);
   ShowWindow(hMinutes_text,SW_SHOWNORMAL);
   EnableWindow(hMinutes_text,TRUE);
   // show the label "Moves:" instead of "Ply:"
   ShowWindow(hPly_text,SW_HIDE);
   ShowWindow(hMoves_text,SW_SHOWNORMAL);
}

BOOL SearchLimitDialog::command(int id, WORD msg)
{
   Search_Limit_Options *opts;
   switch (id) 
   {
   case IDP_TIMELIMIT:
     do_time_limit();
     opts= (Search_Limit_Options*)getObject();
//     strcpy(opts->move_or_ply,""); // set default
//     strcpy(opts->time_limit,"");
//     linkObject(opts);
     break;
   case IDP_FIXEDPLY:
     do_fixed_ply();
     opts = (Search_Limit_Options*)getObject();
//     strcpy(opts->move_or_ply,"2"); // set default
//     linkObject(opts);
     break;
   default:
     break;
   }
   return WPDialogModal::command(id, msg); 
}