// Copyright 1993 by Jon Dart.  All Rights Reserved.
#ifndef _SEARCH_LIMIT_OPTIONS_H
#define _SEARCH_LIMIT_OPTIONS_H

#include <wpp.h>
#include <wpdlg.h>

#define IDP_OK 104
#define IDP_CANCEL 105
#define IDP_SEARCHTYPE 101
#define IDP_TIMELIMIT 103
#define IDP_FIXEDPLY 102
#define IDP_MOVES_OR_PLY 106
#define IDP_MINUTES 107
#define IDP_MOVES_TEXT 108
#define IDP_PLY_TEXT 109
#define IDP_MINUTES_TEXT 110

struct Search_Limit_Options
{
   // holds state of the dialog
   int search_type;
   char move_or_ply[20];
   char time_limit[20];
};

class SearchLimitDialog : public WPDialogModal
{
    // handles the Search Limit ... dialog box in the Options menu.

public:

    SearchLimitDialog(WPWin *pwin, Search_Limit_Options *options);
    
    void initDlg();
    
    BOOL command( int id, WORD msg );
    
private:
    void do_fixed_ply();
    void do_time_limit();
    HWND hMinutes_field, hMoves_text, hMinutes_text;
    HWND hPly_text;
    static WPControlMap ControlMap[];
    int initial_search_type;

};

#endif